# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Labservices::Mgmt::V2018_10_15
  module Models
    #
    # This represents the details about a User's environment and its state.
    #
    class EnvironmentDetails

      include MsRestAzure

      # @return [String] Name of the Environment
      attr_accessor :name

      # @return [String] Description of the Environment
      attr_accessor :description

      # @return [String] Resource Id of the environment
      attr_accessor :id

      # @return [String] The provisioning state of the environment. This also
      # includes LabIsFull and NotYetProvisioned status.
      attr_accessor :provisioning_state

      # @return [VirtualMachineDetails] Details of backing DTL virtual machine
      # with compute and network details.
      attr_accessor :virtual_machine_details

      # @return [LatestOperationResult] The details of the latest operation.
      # ex: status, error
      attr_accessor :latest_operation_result

      # @return [String] Publishing state of the environment setting Possible
      # values are Creating, Created, Failed
      attr_accessor :environment_state

      # @return [Duration] How long the environment has been used by a lab user
      attr_accessor :total_usage

      # @return [DateTime] When the password was last reset on the environment.
      attr_accessor :password_last_reset


      #
      # Mapper for EnvironmentDetails class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'EnvironmentDetails',
          type: {
            name: 'Composite',
            class_name: 'EnvironmentDetails',
            model_properties: {
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'description',
                type: {
                  name: 'String'
                }
              },
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'provisioningState',
                type: {
                  name: 'String'
                }
              },
              virtual_machine_details: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'virtualMachineDetails',
                type: {
                  name: 'Composite',
                  class_name: 'VirtualMachineDetails'
                }
              },
              latest_operation_result: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'latestOperationResult',
                type: {
                  name: 'Composite',
                  class_name: 'LatestOperationResult'
                }
              },
              environment_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'environmentState',
                type: {
                  name: 'String'
                }
              },
              total_usage: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'totalUsage',
                type: {
                  name: 'TimeSpan'
                }
              },
              password_last_reset: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'passwordLastReset',
                type: {
                  name: 'DateTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
